Name: stanse
Version: 1.2.0
Release: 1%{?dist}
License: GPLv2
Group: Development/Tools
Summary: An automatic bug-finding tool for C
Url: http://stanse.fi.muni.cz/
# The 1.2.0 upstream package was obtained from
# http://download.opensuse.org/repositories/home://jirislaby://stanse/Fedora_14/src/stanse-1.2.0-2.3.src.rpm
# Upstream needs to be notified that the release is missing
# in http://stanse.fi.muni.cz/download/
Source0: stanse-%{version}.tar.bz2
#Source0: http://stanse.fi.muni.cz/download/stanse-%%{version}.tar.bz2
Source1: stanse
Source2: stanse-make
Source3: stanse.desktop
Patch0: stanse-buildfixes.patch
Patch1: stanse-stpreprocpath.patch
Patch2: stanse-nohome.patch
Patch3: stanse-iconpath.patch
BuildRequires: ant gcc graphviz cpptasks
BuildRequires: java-devel >= 1:1.6.0
BuildRequires: jpackage-utils
BuildRequires: dom4j log4j jgrapht
BuildRequires: com.inamik.utils.tableformatter
BuildRequires: antlr3-C-devel antlr3-tool antlr3-java ant-antlr3
BuildRequires: swing-layout jaxen jopt-simple
BuildRequires: desktop-file-utils
Requires: java >= 1:1.6.0
Requires: jpackage-utils
Requires: dom4j log4j jgrapht
Requires: com.inamik.utils.tableformatter
Requires: antlr3-java
Requires: swing-layout jaxen jopt-simple
Requires: cpp

%description
An implementation of modern approaches to static analysis and
automatic bug finding for programs written in C. Stanse can
automatically discover some types of bugs in real-life sized projects.

%package web
Summary: Stanse web interface
BuildArch: noarch

%description web
Web front end for presentation of errors found and dumped by Stanse.

%package javadoc
Summary: Javadoc for %{name}
Group: Documentation
BuildArch: noarch
Requires: jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q
%patch0 -p1 -b .buildfixes
%patch1 -p1 -b .stpreprocpath
%patch2 -p1 -b .nohome
%patch3 -p1 -b .iconpath

# Remove all embedded dependencies
rm -rf src/cparser-c/lib dist/lib tools

%build
export CLASSPATH=`build-classpath antlr3 antlr3-runtime dom4j log4j ant/cpptasks ant/ant-antlr3 swing-layout jaxen jgrapht jopt-simple com.inamik.utils.tableformatter`
export ANTLR_HOME=/usr/share/java
ant jar javadoc

%install
mkdir -p $RPM_BUILD_ROOT%{_javadir}/
install -m 644 dist/stanse.jar $RPM_BUILD_ROOT%{_javadir}/stanse.jar

mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/stanse
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/stanse-make
install -m 755 dist/bin/st_xml_bugcount $RPM_BUILD_ROOT%{_bindir}/st_xml_bugcount
install -m 755 dist/bin/stcc $RPM_BUILD_ROOT%{_bindir}/stcc
install -m 755 dist/bin/stcparser-c $RPM_BUILD_ROOT%{_bindir}/stcparser-c
install -m 755 dist/bin/stpreproc $RPM_BUILD_ROOT%{_bindir}/stpreproc
install -m 755 dist/www/st_xml2sqlite3 $RPM_BUILD_ROOT%{_bindir}/st_xml2sqlite3

mkdir -p $RPM_BUILD_ROOT%{_datadir}/stanse
install -m 644 statistics/sort.xsl $RPM_BUILD_ROOT%{_datadir}/stanse/stats-sort.xsl
install -m 644 dist/stanse_icon.png $RPM_BUILD_ROOT%{_datadir}/stanse/stanse_icon.png
cp -rf dist/data/* $RPM_BUILD_ROOT%{_datadir}/stanse

mkdir -p $RPM_BUILD_ROOT%{_datadir}/stanse/xsd
cp -rf xsd/* $RPM_BUILD_ROOT%{_datadir}/stanse/xsd

mkdir -p $RPM_BUILD_ROOT%{_datadir}/stanse/www
cp -rf dist/www/*.cgi $RPM_BUILD_ROOT%{_datadir}/stanse/www

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
desktop-file-install --dir=${RPM_BUILD_ROOT}%{_datadir}/applications %{SOURCE3}

mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}
cp -rf dist/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%files
%defattr(-,root,root,-)
%doc README examples
%{_bindir}/st_xml_bugcount
%{_bindir}/stanse
%{_bindir}/stanse-make
%{_bindir}/stcc
%{_bindir}/stcparser-c
%{_bindir}/stpreproc
%dir %{_datadir}/stanse
%{_datadir}/stanse/checkers
%{_datadir}/stanse/xsd
%{_datadir}/stanse/stanse_icon.png
%{_datadir}/stanse/stats-sort.xsl
%{_javadir}/stanse.jar
%{_datadir}/applications/stanse.desktop

%files web
%defattr(-,root,root,-)
%{_bindir}/st_xml2sqlite3
%{_datadir}/stanse/www

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}

%changelog
* Mon Apr 25 2011 Karel Klíč <kklic@redhat.com> - 1.2.0-1
- Initial packaging inspired by openSUSE package
